/*******************************************************************************************
*
*	void	TempMeasure(uchar	ucChan)
*	Temperatur Messung vornehmen
*	Kanalnummer in ucChan ( 0..3 )
*	Ergebnis in fTempVal
*
********************************************************************************************/
#include <math.h>
#include <reg51.h>

extern	int		DualSlope(unsigned char);

		float	fTempVal[4];

#define uchar unsigned char

#define	a 3.9083E-3					/* Linearisierungs konstanten */
#define b -5.8026E-7
#define Ik 0.001					/* Mess Strom */
#define Rs 84.27					/* Widerstand am unteren Messbereichsende hier -40 */
#define k 23.7						/* Verstaerkungsfaktor */
#define k1 (Rs*Ik*k)				/* Verrechnungs faktor */
#define k2 (100.0*k*Ik)				/* Verrechnungs faktor */
#define Step 0.00012207				/* AD Wandler einheit */

void	TempMeasure(uchar	ucChan)
{
	int		iAutoZeroVal;
	int		iTMess;
	uchar	n;
	float	fV;

	// Messkanal setzen
	P1 = (P1 & 0x9f) | (ucChan << 5) & 0x60;

	// Auto zero messung vornehmen
	for(n=0;n<5;n++)
		iAutoZeroVal = DualSlope(0);
	// Temperaturmessung vornehmen
	iTMess = DualSlope(1) - iAutoZeroVal;
	// Messwert linearisieren und speichern
	fV = ((float)iTMess*Step + k1) / k2 - 1.0;
	fTempVal[ucChan] = -sqrt(fV/b + (a/(2*b)) * (a/(2*b)) ) - a/(2*b);
}

