
;-----------------------------------------------------------------------
;
;	Treiber fuer serielle Schnittstelle
;
;	void	InitSerial()
;
;	Initialisierung der schnittstelle
;
;	void	PutChar(byte ch)
;
;	gibt ein zeichen aus
;
;	byte	GetChar(void)
;
;	holt ein zeichen aus dem buffer
;
;	byte	GetCharCount(void)
;
;	gibt die anzahl der zeichen im buffer zurueck
;
;------------------------------------------------------------------------
	public	InitSerial,_PutChar,GetChar,GetCharCount


Buffersize	equ	8

?PR?seriell?seriell	segment	CODE
?DT?seriell		segment	DATA
;?ID?seriell		segment	IDATA
?BI?seriell		segment	BIT

rseg	?DT?seriell

CharInCnt:	ds	1
CharInPtr:	ds	1
CharOutPtr:	ds	1
RingBuffer:	ds      BufferSize

rseg	?BI?seriell

TxEmptyFlag:   dbit	1

;rseg	?ID?seriell


		cseg	at 23h
		ljmp    SerialService

rseg 	?PR?seriell?seriell

;----------- zeichen ausgeben -------------------------------------------

_PutChar:       jnb	TxEmptyFlag,_PutChar	;transmitter frei ?
		clr	TxEmptyFlag
		mov	SBUF,r7
		ret

;----------- anzahl der zeichen im buffer ausgeben ----------------------

GetCharCount:	mov	r7,CharInCnt
		ret

;------------- schnittstelle initialisieren -----------------------------

InitSerial:  	clr	ES
		mov	CharInPtr,#RingBuffer
		mov     CharOutPtr,#RingBuffer
		mov	CharInCnt,#0
		setb	TxEmptyFlag

		mov	a,TMOD			;8 bit auto reload
		anl	a,#00001111b
		orl	a,#00100000b
		mov	TMOD,a
		mov	TH1,#0fdh		;9600 Bd
		setb	TR1			;timer freigeben

Init_1:		mov     SCON,#01110000b
		setb	ES
		ret

;-------------  zeichen einlesen ------------------------------------------

GetChar:	mov	a,CharInCnt   		;zeichen im buffer?
		jz	GetChar			;nein dann warten
		clr	ES
		dec	CharInCnt		;cnt --
		mov	r0,CharOutPtr		;ptr laden
		mov	a,@r0			;zeichen aus buffer holen
		mov	r7,a			;in R7 speichern

		mov	a,CharOutPtr		;ptr einmal rund ?
		clr	c
		subb	a,#RingBuffer + BufferSize - 1
		jnc	InChar_2		;ja dann ptr neu setzen
		inc	CharOutPtr
		sjmp	InChar_3
InChar_2:	mov	CharOutPtr,#RingBuffer
InChar_3:	setb	ES
		ret

;---------------------------------------------------------------------------
;
;	service routine fuer serielle schnittstelle
;
;---------------------------------------------------------------------------

SerialService:	push	psw
		push	acc
		mov	a,r0
		push	acc

		jnb	TI,Ser_1		;transmitt interrupt ?
		clr	TI
		setb	TxEmptyFlag

Ser_1:          jnb	RI,SerialFull		;zeichen da?
		mov	a,CharInCnt		;noch platz im buffer ?
		clr	c
		subb	a,#BufferSize
		jnc	SerialFull		;nein
		inc	CharInCnt		;ja cnt ++
		mov	a,SBUF			;zeichen einlesen
		clr	RI			;flag loeschen
		mov	r0,CharInPtr		;ptr holen
		mov	@r0,a			;zeichen speichern
		mov	a,CharInPtr		;ptr einmal rund ?
		clr	c
		subb	a,#RingBuffer + BufferSize - 1
		jnc	Ser_2			;ja dann ptr neu setzen
		inc	CharInPtr
		sjmp	SerialFull
Ser_2:		mov	CharInPtr,#RingBuffer

SerialFull:	pop	acc
		mov	r0,a
		pop	acc
		pop	psw
		reti

		end